:::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: This cmd file preps the hard drive for restoring a
:: new base OS by only removing the first partition.
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::

@ECHO OFF

:: Delete the first partition only
:: If the first "partition" is free space, this will do nothing

SET DELCDISK=0
IF NOT "%1" == "" SET DELCDISK=%1

:: This script will have to be created by the python code so we can get the disk number first from ndisk instead
:: of hardcoding the disk=0
::ECHO SELECT DISK %DELCDISK% >%RAMD%\DELC.SCP
::ECHO SELECT PARTITION 1 >>%RAMD%\DELC.SCP
::ECHO DELETE PARTITION OVERRIDE NOERR >>%RAMD%\DELC.SCP
::ECHO EXIT>>%RAMD%\DELC.SCP

ECHO import ndisk>%RAMD%\DELC.PY
ECHO import iubutils>>%RAMD%\DELC.PY
ECHO import os, time, string>>%RAMD%\DELC.PY
ECHO import nlslocal>>%RAMD%\DELC.PY

ECHO def FindSPnum(tryDiskpart = True, useDriveLetter = None):>>%RAMD%\DELC.PY
ECHO     script = open(iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'VOLUMES.SCP'), 'w+')>>%RAMD%\DELC.PY
ECHO     script.write('LIST VOLUME' + os.linesep)>>%RAMD%\DELC.PY
ECHO     script.write('EXIT' + os.linesep)>>%RAMD%\DELC.PY
ECHO     script.close()>>%RAMD%\DELC.PY
ECHO     iubutils.log(_(u'Running diskpart to list all volumes'))>>%RAMD%\DELC.PY
ECHO     volumes = os.popen('diskpart /s ' + iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'VOLUMES.SCP'))>>%RAMD%\DELC.PY
ECHO     sp_vol_num = -1>>%RAMD%\DELC.PY
ECHO     if volumes:>>%RAMD%\DELC.PY
ECHO         try:>>%RAMD%\DELC.PY
ECHO             splabels = iudeploy.getSPLabels()>>%RAMD%\DELC.PY
ECHO         except:>>%RAMD%\DELC.PY
ECHO         #Change for Vista>>%RAMD%\DELC.PY
ECHO             splabels = ['IBM_SERVICE', 'SERVICEV001', 'SERVICEV002']>>%RAMD%\DELC.PY
ECHO         line=volumes.readline()>>%RAMD%\DELC.PY
ECHO         while (line):>>%RAMD%\DELC.PY
ECHO             for label in splabels:>>%RAMD%\DELC.PY
ECHO                 if string.upper(line).find(label) != -1:>>%RAMD%\DELC.PY
ECHO                     line2 = string.split(line)>>%RAMD%\DELC.PY
ECHO                     if len(line2):>>%RAMD%\DELC.PY
ECHO                         try:>>%RAMD%\DELC.PY
ECHO                             sp_vol_num = int(line2[1])>>%RAMD%\DELC.PY
ECHO                             break>>%RAMD%\DELC.PY
ECHO                         except:>>%RAMD%\DELC.PY
ECHO                             pass>>%RAMD%\DELC.PY
ECHO             line=volumes.readline()>>%RAMD%\DELC.PY
ECHO     volumes.close()>>%RAMD%\DELC.PY
ECHO     try: >>%RAMD%\DELC.PY
ECHO         disknum = ndisk.getNonUSBDriveNumPy(0)>>%RAMD%\DELC.PY
ECHO     except: >>%RAMD%\DELC.PY
ECHO         disknum = 0 >>%RAMD%\DELC.PY
ECHO     script = open(iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DETAILS.SCP'), 'w+')>>%RAMD%\DELC.PY
ECHO     script.write('SELECT DISK '+ str(disknum) + os.linesep)>>%RAMD%\DELC.PY
ECHO     script.write('SELECT VOLUME ' + str(sp_vol_num) + os.linesep)>>%RAMD%\DELC.PY
ECHO     script.write('DETAIL PARTITION ' + os.linesep)>>%RAMD%\DELC.PY
ECHO     script.write('EXIT' + os.linesep)>>%RAMD%\DELC.PY
ECHO     script.close()>>%RAMD%\DELC.PY
ECHO     iubutils.log(_(u'Running diskpart to detail partitions'))>>%RAMD%\DELC.PY
ECHO     partitions = os.popen('diskpart /s ' + iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DETAILS.SCP'))>>%RAMD%\DELC.PY
ECHO     sp_par_num = -1>>%RAMD%\DELC.PY
ECHO     if partitions:>>%RAMD%\DELC.PY
ECHO         line=partitions.readline()>>%RAMD%\DELC.PY
ECHO         while (line):>>%RAMD%\DELC.PY
ECHO            line2 = string.split(line)>>%RAMD%\DELC.PY
ECHO            if (-1 == sp_par_num) and (len(line2) ==2):>>%RAMD%\DELC.PY
ECHO                try:>>%RAMD%\DELC.PY
ECHO                    sp_par_num = int(line2[1])>>%RAMD%\DELC.PY
ECHO                    break>>%RAMD%\DELC.PY
ECHO                except:>>%RAMD%\DELC.PY
ECHO                    pass>>%RAMD%\DELC.PY
ECHO            line=partitions.readline()>>%RAMD%\DELC.PY
ECHO         partitions.close()>>%RAMD%\DELC.PY
ECHO     return sp_par_num>>%RAMD%\DELC.PY

ECHO sp_num = FindSPnum()>>%RAMD%\DELC.PY
ECHO iubutils.log('Delete C Only - Checking for SP Position', 'stamp.log')>>%RAMD%\DELC.PY
ECHO try: >>%RAMD%\DELC.PY
ECHO   disknum = ndisk.getNonUSBDriveNumPy(0)>>%RAMD%\DELC.PY
ECHO except: >>%RAMD%\DELC.PY
ECHO   disknum = 0 >>%RAMD%\DELC.PY
ECHO script = open(iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DELC.SCP'), 'w+')>>%RAMD%\DELC.PY
ECHO script.write('SELECT DISK ' + str(disknum) + os.linesep)>>%RAMD%\DELC.PY
ECHO if sp_num == 1:>>%RAMD%\DELC.PY
ECHO     iubutils.log('SP Position at front')>>%RAMD%\DELC.PY
ECHO     script.write('SELECT PARTITION 2' + os.linesep)>>%RAMD%\DELC.PY
ECHO else:>>%RAMD%\DELC.PY
ECHO     if (-1 == sp_num) and ndisk.getFreeSpaceFrontPy(disknum):>>%RAMD%\DELC.PY
ECHO         iubutils.log('SP not found')>>%RAMD%\DELC.PY
ECHO         script.write('SELECT PARTITION 2' + os.linesep)>>%RAMD%\DELC.PY
ECHO     else:>>%RAMD%\DELC.PY
ECHO         iubutils.log('SP at back')>>%RAMD%\DELC.PY
ECHO         script.write('SELECT PARTITION 1' + os.linesep)>>%RAMD%\DELC.PY
ECHO script.write('DELETE PARTITION OVERRIDE NOERR' + os.linesep)>>%RAMD%\DELC.PY
ECHO script.write('EXIT' + os.linesep)>>%RAMD%\DELC.PY
ECHO script.close()>>%RAMD%\DELC.PY
ECHO import iudeploy>>%RAMD%\DELC.PY
ECHO iubutils.log('Delete C Only - Free space NOT found, delete C partition')>>%RAMD%\DELC.PY
ECHO iudeploy.spawn('diskpart', '/s ' + iubutils.osjoin(string.strip(os.getenv('RAMD', 'Z:')), 'DELC.SCP'), string.strip(os.getenv('RAMD', 'Z:')), True, False)>>%RAMD%\DELC.PY
ECHO time.sleep(5)>>%RAMD%\DELC.PY

IF "%IUDEBUG%" == ""     python.exe %RAMD%\DELC.PY
IF NOT "%IUDEBUG%" == "" python.exe %RAMD%\DELC.PY

SET DELCDISK=
